package com.partisiablockchain.contract;

/*
 * Copyright (C) 2022 - 2023 Partisia Blockchain Foundation
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.SerializationFeature;
import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.errorprone.annotations.CheckReturnValue;
import com.partisiablockchain.serialization.HashHistoryStorage;
import com.partisiablockchain.serialization.SerializationResult;
import com.partisiablockchain.serialization.StateObjectMapper;
import com.partisiablockchain.serialization.StateSerializable;
import com.partisiablockchain.serialization.StateSerializer;
import com.partisiablockchain.serialization.StateStorage;
import com.secata.tools.coverage.ExceptionConverter;
import java.util.Map;
import org.assertj.core.api.Assertions;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Checker system to verify that objects are valid {@link StateSerializable} objects.
 *
 * <p>Partisia Blockchain enforces that contract states must be tagged using the {@link
 * StateSerializable} interface and additionally tagged with the {@code @Immutable} annotation, but
 * there is not static analysis for whether the given class can be serialized by the underlying
 * blockchain. There are several known cases where the serialization system fails:
 *
 * <ul>
 *   <li>When the state contains non-{@link StateSerializable} fields, for example {@link Map}.
 *   <li>When the state contains fields with generic types.
 * </ul>
 *
 * <p>This verifier checks that any given object is actually {@link StateSerializable} by
 * serializing it, reading it up again, and comparing it.
 *
 * <p>Properties checked:
 *
 * <ul>
 *   <li>That object can be serialized to bytes.
 *   <li>That generated bytes can be deserialized.
 *   <li>That deserialized state is identical to original object.
 *   <li>That JSON representation of the state is identical between original and deserialized
 *       object.
 * </ul>
 *
 * <p>Part of class was source-copied from <a
 * href="https://gitlab.com/partisiablockchain/core/contract">core/contract</a>.
 */
@CheckReturnValue
public final class StateSerializableChecker {

  private static final Logger logger = LoggerFactory.getLogger(StateSerializableChecker.class);

  private static final ObjectMapper jsonMapper =
      StateObjectMapper.createObjectMapper().configure(SerializationFeature.INDENT_OUTPUT, true);

  private StateSerializableChecker() {}

  /**
   * Assert that the given state object can be serialized and then later de-serialized to the same
   * state.
   *
   * @param <T> Type of state.
   * @param stateStorage Storage used to write state contents to, and read from. External injection
   *     is required in case the given {@code stateObject} has previously been deserialized, and
   *     contains lazy {@code AvlTree}s. Not nullable.
   * @param stateObject Object to serialize. Not nullable.
   * @return Returns the deserialized state. Will be equal to the original, as defined by {@link
   *     StateSerializableEquality}.
   * @throws RuntimeException if the serialization fails or doesn't produce the same state as was
   *     written.
   */
  @CanIgnoreReturnValue
  @SuppressWarnings("unchecked")
  public static <T extends StateSerializable> T assertStateSerializable(
      StateStorage stateStorage, final T stateObject) {
    return assertStateSerializable(
        stateStorage, stateObject, (Class<? extends T>) stateObject.getClass());
  }

  /**
   * Assert that the given state object can be serialized and then later de-serialized to the same
   * state.
   *
   * @param <T> Type of state.
   * @param stateStorage Storage used to write state contents to, and read from. External injection
   *     is required in case the given {@code stateObject} has previously been deserialized, and
   *     contains lazy {@code AvlTree}s. Not nullable.
   * @param stateObject Object to serialize. Nullable.
   * @param stateType Type of state. Required when state is null.
   * @return Returns the deserialized state. Will be equal to the original, as defined by {@link
   *     StateSerializableEquality}.
   * @throws RuntimeException if the serialization fails or doesn't produce the same state as was
   *     written.
   */
  @CanIgnoreReturnValue
  public static <T extends StateSerializable> T assertStateSerializable(
      StateStorage stateStorage, final T stateObject, final Class<? extends T> stateType) {
    return assertStateSerializable(stateStorage, stateObject, stateType, new Class<?>[0]);
  }

  /**
   * Assert that the given state object can be serialized and then later de-serialized to the same
   * state.
   *
   * @param <T> Type of state.
   * @param stateStorage Storage used to write state contents to, and read from. External injection
   *     is required in case the given {@code stateObject} has previously been deserialized, and
   *     contains lazy {@code AvlTree}s. Not nullable.
   * @param stateObject Object to serialize. Nullable.
   * @param stateType Type of state. Required when state is null.
   * @param stateTypeParameters Type parameters of state type.
   * @return Returns the deserialized state. Will be equal to the original, as defined by {@link
   *     StateSerializableEquality}.
   * @throws RuntimeException if the serialization fails or doesn't produce the same state as was
   *     written.
   */
  @CanIgnoreReturnValue
  public static <T extends StateSerializable> T assertStateSerializable(
      final StateStorage stateStorage,
      final T stateObject,
      final Class<? extends T> stateType,
      final Class<?>[] stateTypeParameters) {

    // Setup
    final StateSerializer serializer =
        new StateSerializer(new HashHistoryStorage(stateStorage), true);

    // Serialize to bytes
    logger.info("Serialize: {}", stateObject);
    final SerializationResult serializationResult =
        serializer.write(stateObject, stateTypeParameters);
    if (stateObject != null) {
      Assertions.assertThat(serializer.createHash(stateObject, stateTypeParameters))
          .isEqualTo(serializationResult.hash());
    }

    // Deserialize from bytes
    logger.info("DeSerialize");
    final T stateDeserialized =
        serializer.read(serializationResult.hash(), stateType, stateTypeParameters);

    // Write object again
    logger.info("Serialize again");
    final SerializationResult reSerializationResult =
        serializer.write(stateDeserialized, stateTypeParameters);

    Assertions.assertThat(reSerializationResult).isNotNull();
    Assertions.assertThat(reSerializationResult.hash()).isEqualTo(serializationResult.hash());
    Assertions.assertThat(reSerializationResult.totalByteCount())
        .isEqualTo(serializationResult.totalByteCount());

    // Verify that state is stable across serialization
    logger.info("Verify: {}", stateDeserialized);
    assertStatesStableAcrossSerialization(stateObject, stateDeserialized);

    return stateDeserialized;
  }

  static String writeToJson(StateSerializable state) {
    return ExceptionConverter.call(
        () -> jsonMapper.writeValueAsString(state), "Unable to write value to json");
  }

  static void assertStatesStableAcrossSerialization(
      StateSerializable stateOriginal, StateSerializable stateDeserialized) {
    StateSerializableEquality.assertStatesEqual(stateDeserialized, stateOriginal);

    // Check that json matches
    final String jsonOfStateOriginal = writeToJson(stateOriginal);
    final String jsonOfstateDeserialized = writeToJson(stateDeserialized);
    Assertions.assertThat(jsonOfstateDeserialized)
        .describedAs("Before and after serialization to bytes should give same json")
        .isEqualTo(jsonOfStateOriginal);
  }
}
